#!/usr/bin/env node
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { execSync } from 'child_process';
import enquirer from 'enquirer';
import ora from 'ora';
import parseArgs from 'yargs-parser';
import { ChatGPTClient } from './client.js';
import { ensureSessionToken } from './config.js';
var CUSTOM_MESSAGE_OPTION = '[write own message]...';
var MORE_OPTION = '[ask for more ideas]...';
var spinner = ora();
var argv = parseArgs(process.argv.slice(2));
var conventionalCommit = argv.conventional || argv.c;
var CONVENTIONAL_REQUEST = conventionalCommit ? "following conventional commit (<type>: <subject>)" : '';
var diff = '';
try {
    diff = execSync('git diff --cached').toString();
    if (!diff) {
        console.log('No changes to commit.');
        process.exit(0);
    }
}
catch (e) {
    console.log('Failed to run git diff --cached');
    process.exit(1);
}
run(diff)
    .then(function () {
    process.exit(0);
})["catch"](function (e) {
    console.log('Error: ' + e.message);
    process.exit(1);
});
function run(diff) {
    return __awaiter(this, void 0, void 0, function () {
        var api, _a, firstRequest, firstRequestSent, choices, answer, e_1;
        var _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    _a = ChatGPTClient.bind;
                    _b = {};
                    return [4 /*yield*/, ensureSessionToken()];
                case 1:
                    api = new (_a.apply(ChatGPTClient, [void 0, (_b.sessionToken = _c.sent(),
                            _b)]))();
                    spinner.start('Authorizing with OpenAI...');
                    return [4 /*yield*/, api.ensureAuth()];
                case 2:
                    _c.sent();
                    spinner.stop();
                    firstRequest = "Suggest me a few good commit messages for my commit ".concat(CONVENTIONAL_REQUEST, ".\n") +
                        '```\n' +
                        diff +
                        '\n' +
                        '```\n\n' +
                        "Output results as a list, not more than 6 items.";
                    firstRequestSent = false;
                    _c.label = 3;
                case 3:
                    if (!true) return [3 /*break*/, 9];
                    return [4 /*yield*/, getMessages(api, firstRequestSent
                            ? "Suggest a few more commit messages for my changes (without explanations) ".concat(CONVENTIONAL_REQUEST)
                            : firstRequest)];
                case 4:
                    choices = _c.sent();
                    _c.label = 5;
                case 5:
                    _c.trys.push([5, 7, , 8]);
                    return [4 /*yield*/, enquirer.prompt({
                            type: 'select',
                            name: 'message',
                            message: 'Pick a message',
                            choices: choices
                        })];
                case 6:
                    answer = _c.sent();
                    firstRequestSent = true;
                    if (answer.message === CUSTOM_MESSAGE_OPTION) {
                        execSync('git commit', { stdio: 'inherit' });
                        return [2 /*return*/];
                    }
                    else if (answer.message === MORE_OPTION) {
                        return [3 /*break*/, 3];
                    }
                    else {
                        execSync("git commit -m '".concat(answer.message.replace(/'/, "\\'"), "'"), { stdio: 'inherit' });
                        return [2 /*return*/];
                    }
                    return [3 /*break*/, 8];
                case 7:
                    e_1 = _c.sent();
                    console.log('Aborted.');
                    console.log(e_1);
                    process.exit(1);
                    return [3 /*break*/, 8];
                case 8: return [3 /*break*/, 3];
                case 9: return [2 /*return*/];
            }
        });
    });
}
function getMessages(api, request) {
    return __awaiter(this, void 0, void 0, function () {
        var response, messages;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    spinner.start('Asking ChatGPT 🤖 for commit messages...');
                    return [4 /*yield*/, api.getAnswer(request)];
                case 1:
                    response = _a.sent();
                    messages = response
                        .split('\n')
                        .filter(function (line) { return line.match(/^(\d+\.|-|\*)\s+/); })
                        .map(normalizeMessage);
                    spinner.stop();
                    messages.push(CUSTOM_MESSAGE_OPTION, MORE_OPTION);
                    return [2 /*return*/, messages];
            }
        });
    });
}
function normalizeMessage(line) {
    return line
        .replace(/^(\d+\.|-|\*)\s+/, '')
        .replace(/^[`"']/, '')
        .replace(/[`"']$/, '')
        .replace(/[`"']:/, ':') // sometimes it formats messages like this: `feat`: message
        .replace(/:[`"']/, ':') // sometimes it formats messages like this: `feat:` message
        .replace(/\\n/g, '');
}
